
#include <math.h>

#include "Figure.h"
#include "Point2D.h"
#include "Line.h"
#include "Segment.h"
#define PI 3.14159265358979323846
//---------------------------------------------------------------------------
Figure::Figure():
   ang(0)
{
}


Figure::~Figure()
{
}

//---------------------------------------------------------------------------

Point2D Figure::TopLeft()
{
   return Point2D(topleftX, topleftY);
}

Point2D Figure::TopRight()
{
   return Point2D(toprightX, toprightY);
}

Point2D Figure::BottomLeft()
{
   return Point2D(bottomleftX, bottomleftY);
}

Point2D Figure::BottomRight()
{
   return Point2D(bottomrightX, bottomrightY);
}

double Figure::AngleR()
{
   return ang;
}

void Figure::SetAngleR(double angle)
{
   while(angle>=2*PI)
   angle-=2*PI;
   while(angle<0)
   angle+=2*PI;
   ang=angle;
}

void Figure::SetTopPoints(double lx, double ly, double rx, double ry)
{
  topleftX=lx;
  topleftY=ly;
  toprightX=rx;
  toprightY=ry;
}

void Figure::SetBottomPoints(double lx, double ly, double rx, double ry)
{
  bottomleftX=lx;
  bottomleftY=ly;
  bottomrightX=rx;
  bottomrightY=ry;
}


//---------------------------------------------------------------------------

void Figure::ScaleOrig(double fx, double fy)
{
  Point2D p=Center();
  Translate(-p.X(), -p.Y());
  Scale(fx,fy);
  Translate(p.X(), p.Y());
}

void Figure::ScalePt(double fx, double fy, const Point2D& p)
{
  Translate(-p.X(), -p.Y());
  Scale(fx,fy);
  Translate(p.X(), p.Y());
}

void Figure::RotateAround(double angle)
{
  Point2D p=Center();
  Translate(-p.X(), -p.Y());
  Rotate(angle);
  SetAngleR(angle);
  Translate(p.X(), p.Y());
}

void Figure::RotateAround(double angle, const Point2D& p)
{
  Translate(-p.X(), -p.Y());
  Rotate(angle);
  Translate(p.X(), p.Y());
}

void Figure::Mirror(const Line& z)
{
  Point2D p(z.Intersection(z.Perpendicular(Point2D())));
  Translate(-p.X(), -p.Y());
  Rotate(-z.Angle());
  Scale(1.0, -1.0);
  Rotate(z.Angle());
  Translate(p.X(), p.Y());

}


