#ifndef FigureH
#define FigureH

#include <iostream.h>
#include "Visual.h"
class Point2D;
class Line;

class Figure : public Visual{
   private:
       double topleftX;
       double topleftY;
       double toprightX;
       double toprightY;
       double bottomleftX;
       double bottomleftY;
       double bottomrightX;
       double bottomrightY;
       double ang;
   public:
       Figure();
       virtual ~Figure();

       virtual Point2D TopLeft();
       virtual Point2D TopRight();
       virtual Point2D BottomLeft();
       virtual Point2D BottomRight();
       virtual double AngleR();
       virtual void SetAngleR(double angle);
       virtual void SetTopPoints(double lx, double ly, double rx, double ry);
       virtual void SetBottomPoints(double lx, double ly, double rx, double ry);


       virtual Point2D Vertex(int x) const = 0;
       virtual Point2D Center() const = 0;
       virtual bool Contains (const Point2D& p) = 0;

       virtual void Scale(double fx, double fy) = 0;
       virtual void Translate(double dx, double dy) = 0;
       virtual void Rotate(double angle) = 0;
       virtual Point2D TopLeftLimit() = 0;
       virtual Point2D BottomRightLimit() = 0;

       virtual void Write(ostream& = cout) const = 0;
       virtual void WriteLine(ostream& = cout) const = 0;

       virtual void ScaleOrig(double fx, double fy);
       virtual void ScalePt(double fx, double fy, const Point2D& p);
       virtual void RotateAround(double angle);
       virtual void RotateAround(double angle, const Point2D& p);
       virtual void Mirror(const Line& z);
};

#endif
