//---------------------------------------------------------------------------

#include <math.h>
#pragma hdrstop

#include "Segment.h"
#include "Line.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)

Segment::Segment():
        pinicial(0,0),
        pfinal(0,0)
{
}
Segment::Segment(const Point2D& ini,const Point2D& fin):
        pinicial(ini),
        pfinal(fin)
{
}
Segment::Segment(const Segment& other):
        pinicial(other.pinicial),
        pfinal(other.pfinal)
{
}
Segment::~Segment()
{
}
//---------------------------------------------------------------------------
Point2D Segment::Vertex(int x) const
{
  if (x=1)
  return pinicial;
  if (x=2)
  return pfinal;
}

Point2D Segment::Center() const
{
   return MidlePoint();
}
//-------------------------------------------------------


Point2D Segment::Pinicial() const
{
        double x=pinicial.X();
        double y=pinicial.Y();
        return Point2D (x,y);
}

Point2D Segment::Pfinal() const
{
        double x=pfinal.X();
        double y=pfinal.Y();
        return Point2D (x,y);
}

void Segment::Setpinicial(const Point2D ini)
{
        pinicial=ini;
}

void Segment::Setpfinal(const Point2D fin)
{
        pinicial=fin;
}
//---------------------------------------------------------------------------
void Segment::Scale(double fx, double fy)
{
        pinicial.Scale(fx,fy);
        pfinal.Scale(fx,fy);
}
void Segment::Translate(double fx, double fy)
{
        pinicial.Translate(fx,fy);
        pfinal.Translate(fx,fy);
}
void Segment::Rotate(double angle)
{
        pinicial.Rotate(angle);
        pfinal.Rotate(angle);
}

Point2D Segment::TopLeftLimit()
{
  double Xm=pinicial.X();
  double Ym=pinicial.Y();
  if (pfinal.X()<Xm)
    Xm=pfinal.X();
  if (pfinal.Y()<Ym)
    Ym=pfinal.Y();
  return Point2D(Xm,Ym);
}

Point2D Segment::BottomRightLimit()
{
  double XM=pinicial.X();
  double YM=pinicial.Y();
  if (pfinal.X()>XM)
    XM=pfinal.X();
  if (pfinal.Y()>YM)
    YM=pfinal.Y();
  return Point2D(XM,YM);
}

bool Segment::Contains (const Point2D& p)
{
  return Line(pinicial, pfinal).Has(p);
}

//---------------------------------------------------------------------------
Point2D Segment::MidlePoint()
{
        double x=(pinicial.X()+pfinal.X())/2;
        double y=(pinicial.Y()+pfinal.Y())/2;
        return Point2D (x,y);
}
double Segment::Lenght()
{
        return pinicial.DistanceTo(pfinal);
}

//---------------------------------------------------------------------------
void Segment ::Write(ostream& output) const
{
        pinicial.Write(output);
        output<<" ";
        pfinal.Write(output);
}

void Segment::WriteLine(ostream& output) const
{
        Write(output);
        output<<endl;
}

void Segment::Read(istream& input)
{
        pinicial.Read(input);
        input>>" ";
        pfinal.Read(input);
}
