//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "VisualCircle.h"

//---------------------------------------------------------------------------

#pragma package(smart_init)
//---------------------------------------------------------------------------
VisualCircle::VisualCircle( const Point2D& center, double radius):
        Circle(center,radius)
{
}
//---------------------------------------------------------------------------
VisualCircle::~VisualCircle()
{
}
//---------------------------------------------------------------------------
void VisualCircle::Draw(TCanvas *picture)
{
        picture->Pen->Width = PenWidth();
        picture->Pen->Color = PenColor();
        picture->Brush->Color = BrushColor();
        picture->Pen->Style = PenStyle();
        picture->Brush->Style = BrushStyle();

        Point2D  p1 ( Center().X()-Radius(), Center().Y()- Radius());
        Point2D p2(Center().X()+Radius(),Center().Y()+Radius() );
        picture->Ellipse(p1.X(),p1.Y(),p2.X(),p2.Y());
}
//---------------------------------------------------------------------------
void VisualCircle::Hide(TCanvas *picture)
{
        picture->Pen->Width = PenWidth();
        picture->Pen->Color = clWhite;
        picture->Brush->Color = clWhite;

        Point2D  p1 ( Center().X()-Radius(), Center().Y()- Radius());
        Point2D p2(Center().X()+Radius(),Center().Y()+Radius() );
        picture->Ellipse(p1.X(),p1.Y(),p2.X(),p2.Y());
}

