//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "VisualPolygons.h"

//---------------------------------------------------------------------------

#pragma package(smart_init)
//---------------------------------------------------------------------------
VisualPolygons::VisualPolygons(int count, const Point2D points[]):
        Polygons(count,points)
{
}

VisualPolygons::VisualPolygons(int count, Point2D center, Point2D vertice):
        Polygons(count, center, vertice)
{
}
//---------------------------------------------------------------------------
VisualPolygons::~VisualPolygons()
{
}
//---------------------------------------------------------------------------
void VisualPolygons::Draw(TCanvas *picture)
{
        picture->Pen->Width = PenWidth();
        picture->Pen->Color = PenColor();
        picture->Brush->Color = BrushColor();
        picture->Pen->Style = PenStyle();
        picture->Brush->Style = BrushStyle();

        Windows::TPoint *points;
        points=new Windows::TPoint[Count()];
        for (int i=0;i<Count();i++)
        points[i] = Point(Vertex(i).X() , Vertex(i).Y());
        picture->Polygon(points,Count()-1);
        delete []points;
}
//---------------------------------------------------------------------------
void VisualPolygons::Hide(TCanvas *picture)
{
        picture->Pen->Width = PenWidth();
        picture->Pen->Color = clWhite;
        picture->Brush->Color = clWhite;

        Windows::TPoint *points;
        points=new Windows::TPoint[Count()];
        for (int i=0;i<Count();i++)
        points[i] = Point(Vertex(i).X() , Vertex(i).Y());
        picture->Polygon(points,Count()-1);
        delete []points;
}