//---------------------------------------------------------------------------

#include <clipbrd.hpp>
#include <vcl.h>
#pragma hdrstop

#define pi 3.14159265358979323846
#include "untDraw.h"
#include "Visual.h"
#include "VisualCircle.h"
#include "VisualTriangle.h"
#include "VisualPolygons.h"
#include "VisualLine.h"
#include "Line.h"
#include "Point2D.h"
#include "Figure.h"
#include "untAbout.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "CSPIN"
#pragma resource "*.dfm"
TfrmDraw *frmDraw;
//---------------------------------------------------------------------------
__fastcall TfrmDraw::TfrmDraw(TComponent* Owner)
        : TForm(Owner)
{

auxcenter=Point2D();
f= new VisualLine(Point2D(),Point2D());
f->SetPenWidth(1);
fig= new VisualLine(Point2D(),Point2D());
fig->SetPenWidth(1);
fig->SetPenColor(clWhite);
vertex=0;
penWidth=1;
penColor=clBlack;
brushColor=clWhite;
penStyle=psSolid;
brushStyle=bsClear;
aux=false;
X0=0;
Y0=0;
frmDraw->imgTransparent->Canvas;

}
//---------------------------------------------------------------------------
void __fastcall TfrmDraw::FormDestroy(TObject *Sender)
{

delete fig;
if (!aux)
delete f;
if (vertex!=0){
   delete []lines;
   delete []points;
}

}
//---------------------------------------------------------------------------

void __fastcall TfrmDraw::OpenClick(TObject *Sender)
{

if(OpenPictureDialog1->Execute())
{
       if(FileExists(OpenPictureDialog1->FileName))
       {
           imgTransparent->Picture->LoadFromFile(OpenPictureDialog1->FileName);
       }
       else
       {
           MessageDlg("Ficheiro \n" + OpenPictureDialog1->FileName + "\nNo Existe",
                      mtError, TMsgDlgButtons() <<  mbOK, 0);
       }
}


}
//---------------------------------------------------------------------------

void __fastcall TfrmDraw::SaveClick(TObject *Sender)
{

if(SavePictureDialog1->Execute())
{
   if(! FileExists(SavePictureDialog1->FileName))
   {
      imgTransparent->Picture->SaveToFile(SavePictureDialog1->FileName);
      ShowMessage("Imagem Guardada");
   }
   else
   {
      if( MessageDlg("Substituir " + SavePictureDialog1->FileName,
                mtConfirmation, TMsgDlgButtons() <<  mbYes <<  mbNo, 0)
                == mrYes )
      {
         imgTransparent->Picture->SaveToFile(SavePictureDialog1->FileName);
         ShowMessage("Imagem Guardada");
      }
      else
         ShowMessage("Gravao adiada");
   }
}

}
//---------------------------------------------------------------------------
void __fastcall TfrmDraw::imgTransparentMouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{

X0=X;
Y0=Y;
if (ToolBtnPoint->Down==true)
{
   fig->Hide(frmDraw->imgTransparent->Canvas);
   delete fig;
   fig = new VisualLine(Point2D(X,Y),Point2D(X+1,Y+1));
   fig->SetPenWidth(frmDraw->penWidth);
   fig->SetPenColor(frmDraw->penColor);
   fig->SetPenStyle(frmDraw->penStyle);
   fig->Draw(frmDraw->imgTransparent->Canvas);
}

if (ToolBtnRect->Down==true)
   points= new Point2D[4];

if (ToolBtnRpoly->Down==true)
   points= new Point2D[Count->Text.ToInt()];

if (ToolBtnNpoly->Down==true && vertex==0)
{
   fig->Hide(frmDraw->imgTransparent->Canvas);
   points= new Point2D[Count->Text.ToInt()];
   points[0]=Point2D(X,Y);
   lines= new VisualLine[Count->Text.ToInt()];
   Count->Enabled=false;
}

if (ToolBtnMirror->Down==true || ToolBtnRotate->Down==true)
   lines= new VisualLine[1];


}
//---------------------------------------------------------------------------

void __fastcall TfrmDraw::imgTransparentMouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
imgTransparent->Cursor=crDefault;
if ((ToolBtnTrans->Down==true) && (fig->Contains(Point2D(X,Y))==true))
imgTransparent->Cursor=crSizeAll;
if (ToolBtnFree->Down==true)
imgTransparent->Cursor=crHandPoint;


if( Shift.Contains(ssLeft)){

if (ToolBtnLine->Down==true || ToolBtnCircle->Down==true || ToolBtnTri->Down==true
               || ToolBtnRect->Down==true || ToolBtnRpoly->Down==true)
{
   fig->Hide(frmDraw->imgTransparent->Canvas);
   delete fig;
   double CX=(X0+X)/2;
   double CY=(Y0+Y)/2;

   if (ToolBtnLine->Down==true)
   {
      fig = new VisualLine(Point2D(X0,Y0),Point2D(X,Y));
      StatusBar->SimpleText="Initial Point: "+FloatToStr(X0)+","+
                                Y0+"    Final Point: "+X+","+Y;
   }

   if (ToolBtnCircle->Down==true)
   {
      int radius;
      if (abs(X-X0)>abs(Y-Y0))
         radius=abs(X-CX);
      else
         radius=abs(Y-CY);
      fig = new VisualCircle(Point2D(CX,CY),radius);
      StatusBar->SimpleText="Center: "+FloatToStr(CX)+","+CY+
                                "    Radius: "+radius;
   }

   if (ToolBtnTri->Down==true)
   {
      CX=(3*X0+X)/4;
      CY=(3*Y+Y0)/4;
      fig = new VisualTriangle(Point2D(X0,Y0),Point2D(X0,Y),Point2D(X,Y));
      StatusBar->SimpleText="Initial Point: "+FloatToStr(X0)+","+Y0+
                                "    Final Point: "+X+","+Y;
   }

   if (ToolBtnRect->Down==true)
   {
      points[0]=Point2D(X0,Y0);
      points[1]=Point2D(X,Y0);
      points[2]=Point2D(X,Y);
      points[3]=Point2D(X0,Y);
      fig = new VisualPolygons(4,points);
      StatusBar->SimpleText="Initial Point: "+FloatToStr(X0)+","+Y0+
                                "    Final Point: "+X+","+Y;
   }

   if (ToolBtnRpoly->Down==true)
   {
      if (abs(Y-Y0)>abs(X-X0))
         points[0]=Point2D(CX,Y0);
      else
         points[0]=Point2D(CX,CY-X+CX);

      fig = new VisualPolygons(Count->Text.ToInt(), Point2D(CX,CY), points[0]);


      /*for (int i=0;i<Count->Text.ToInt();i++){
         points[i]=points[0];
         points[i].RotateAround(2*pi*i/Count->Text.ToInt(),Point2D(CX,CY));
      }
      fig = new VisualPolygons(Count->Text.ToInt(),points);*/
      StatusBar->SimpleText="Center: "+FloatToStr(CX)+","+CY+
                                "    Radius: "+abs(Y0-CY);
   }

   fig->SetPenWidth(frmDraw->penWidth);
   fig->SetPenColor(frmDraw->penColor);
   fig->SetBrushColor(frmDraw->brushColor);
   fig->SetPenStyle(frmDraw->penStyle);
   fig->SetBrushStyle(frmDraw->brushStyle);
   fig->Draw(frmDraw->imgTransparent->Canvas);
}
else
{

   if (ToolBtnNpoly->Down==true)
   {
      lines[vertex].Hide(frmDraw->imgTransparent->Canvas);
      lines[vertex] = VisualLine(points[vertex],Point2D(X,Y));
      lines[vertex].SetPenWidth(1);
      lines[vertex].SetPenColor(clBlack);
      lines[vertex].SetPenStyle(psSolid);
      for(int i=0;i<=vertex;i++)
         lines[i].Draw(frmDraw->imgTransparent->Canvas);
      StatusBar->SimpleText="Vertex number: "+FloatToStr(vertex+2)+"    Previous vertex: "+points[vertex].X()
                     +","+points[vertex].Y()+"    Actual vertex: "+X+","+Y;
   }

   if (ToolBtnMirror->Down==true)
   {
      lines[0].Hide(frmDraw->imgTransparent->Canvas);
      lines[0] = VisualLine(Point2D(X0,Y0),Point2D(X,Y));
      lines[0].SetPenWidth(1);
      lines[0].SetPenColor(clBlack);
      lines[0].SetPenStyle(psSolid);
      fig->Draw(frmDraw->imgTransparent->Canvas);
      lines[0].Draw(frmDraw->imgTransparent->Canvas);
      StatusBar->SimpleText="Initial Point: "+FloatToStr(X0)+","+
                                Y0+"    Final Point: "+X+","+Y;
   }

   if (ToolBtnRotate->Down==true)
   {
      lines[0].Hide(frmDraw->imgTransparent->Canvas);
      lines[0] = VisualLine(fig->Center(),Point2D(X,Y));
      lines[0].SetPenWidth(1);
      lines[0].SetPenColor(clBlack);
      lines[0].SetPenStyle(psSolid);
      fig->Hide(frmDraw->imgTransparent->Canvas);

      fig->RotateAround(-fig->AngleR());

      double angle=Line(fig->Center(), Point2D(X,Y)).Angle();
      if (X<fig->Center().X())
         angle+=pi;
      if ((Y==(int)fig->Center().Y()) && (X>fig->Center().X()))
         angle=0;
      if ((X==(int)fig->Center().X()) && (Y<fig->Center().Y()))
         angle=pi/2+pi;


      fig->RotateAround(angle);
      fig->Draw(frmDraw->imgTransparent->Canvas);
      lines[0].Draw(frmDraw->imgTransparent->Canvas); 
      StatusBar->SimpleText="Angle: "+FloatToStr((float)(fig->AngleR()*180/pi));
   }

   if (ToolBtnTrans->Down==true)
   {
      fig->Hide(frmDraw->imgTransparent->Canvas);
      fig->Translate(X-X0, Y-Y0);
      fig->Draw(frmDraw->imgTransparent->Canvas);
      X0=X;
      Y0=Y;
      StatusBar->SimpleText="Center Position: "+FloatToStr(X)+","+Y;
   }

   if (ToolBtnFree->Down==true)
   {
      imgTransparent->Canvas->Pen->Width = penWidth;
      imgTransparent->Canvas->Pen->Color = penColor;
      imgTransparent->Canvas->Pen->Style = penStyle;
      imgTransparent->Canvas->MoveTo(X0,Y0);
      imgTransparent->Canvas->LineTo(X,Y);
      X0=X;
      Y0=Y;
      StatusBar->SimpleText="Pen Position: "+FloatToStr(X)+","+Y;
   }
}
}
else
{
   StatusBar->SimpleText="Position: "+FloatToStr(X)+","+Y;

   








}
}
//---------------------------------------------------------------------------

void __fastcall TfrmDraw::imgTransparentMouseUp(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{

if (ToolBtnMirror->Down==true)
{
   lines[0].Hide(frmDraw->imgTransparent->Canvas);
   fig->Hide(frmDraw->imgTransparent->Canvas);
   if (X0!=X || Y0!=Y)
      fig->Mirror(Line(Point2D(X0,Y0),Point2D(X,Y)));
   fig->Draw(frmDraw->imgTransparent->Canvas);
   delete []lines;
}

if (ToolBtnRotate->Down==true)
{
   lines[0].Hide(frmDraw->imgTransparent->Canvas);
   delete []lines;
   fig->Draw(frmDraw->imgTransparent->Canvas);
}

if (ToolBtnNpoly->Down==true)
{
   vertex++;
   points[vertex]=Point2D(X,Y);
   if (Count->Text.ToInt()==vertex+1)
   {
      delete fig;
      fig = new VisualPolygons(Count->Text.ToInt(),points);
      fig->SetPenWidth(frmDraw->penWidth);
      fig->SetPenColor(frmDraw->penColor);
      fig->SetBrushColor(frmDraw->brushColor);
      fig->SetPenStyle(frmDraw->penStyle);
      fig->SetBrushStyle(frmDraw->brushStyle);
      fig->Draw(frmDraw->imgTransparent->Canvas);
      delete []lines;
      vertex=0;
      Count->Enabled=true;
   }
}

if (ToolBtnRpoly->Down==true || ToolBtnRect->Down==true)
   delete []points;



}
//---------------------------------------------------------------------------

void __fastcall TfrmDraw::BtnPrintClick(TObject *Sender)
{
if (vertex==0)
   fig->Draw(frmDraw->imgTransparent->Canvas);
else
      StatusBar->SimpleText="Finish the polygon first";

}
//---------------------------------------------------------------------------

void __fastcall TfrmDraw::BitBtnZinClick(TObject *Sender)
{
   if (vertex==0){
      fig->Hide(frmDraw->imgTransparent->Canvas);
      fig->ScaleOrig(Zoom->Text.ToDouble(), Zoom->Text.ToDouble());
      fig->Draw(frmDraw->imgTransparent->Canvas);
   }
   else
      StatusBar->SimpleText="Finish the polygon first";

}
//---------------------------------------------------------------------------

void __fastcall TfrmDraw::BitBtnZoutClick(TObject *Sender)
{
   if (vertex==0){
      fig->Hide(frmDraw->imgTransparent->Canvas);
      fig->ScaleOrig(1/Zoom->Text.ToDouble(),1/Zoom->Text.ToDouble());
      fig->Draw(frmDraw->imgTransparent->Canvas);
   }
   else
      StatusBar->SimpleText="Finish the polygon first";

}
//---------------------------------------------------------------------------

void __fastcall TfrmDraw::BitBtnUpClick(TObject *Sender)
{
if (vertex==0){
   fig->Hide(frmDraw->imgTransparent->Canvas);
   fig->Translate(0,-Trans->Text.ToIntDef(0));
   fig->Draw(frmDraw->imgTransparent->Canvas);
}
else
      StatusBar->SimpleText="Finish the polygon first";

}
//---------------------------------------------------------------------------

void __fastcall TfrmDraw::BitBtnLeftClick(TObject *Sender)
{
if (vertex==0){
   fig->Hide(frmDraw->imgTransparent->Canvas);
   fig->Translate(-Trans->Text.ToIntDef(0),0);
   fig->Draw(frmDraw->imgTransparent->Canvas);
}
else
      StatusBar->SimpleText="Finish the polygon first";

}
//---------------------------------------------------------------------------

void __fastcall TfrmDraw::BitBtnDownClick(TObject *Sender)
{
if (vertex==0){
   fig->Hide(frmDraw->imgTransparent->Canvas);
   fig->Translate(0,Trans->Text.ToIntDef(0));
   fig->Draw(frmDraw->imgTransparent->Canvas);
}
else
      StatusBar->SimpleText="Finish the polygon first";

}
//---------------------------------------------------------------------------

void __fastcall TfrmDraw::BitBtnRigthClick(TObject *Sender)
{
if (vertex==0){
   fig->Hide(frmDraw->imgTransparent->Canvas);
   fig->Translate(Trans->Text.ToIntDef(0),0);
   fig->Draw(frmDraw->imgTransparent->Canvas);
}
else
      StatusBar->SimpleText="Finish the polygon first";

}
//---------------------------------------------------------------------------

void __fastcall TfrmDraw::BitBtnRotateClick(TObject *Sender)
{
if (vertex==0){
   fig->Hide(frmDraw->imgTransparent->Canvas);
   fig->RotateAround(((double)Angle->Text.ToIntDef(0)*pi)/180);
   fig->Draw(frmDraw->imgTransparent->Canvas);
}
else
      StatusBar->SimpleText="Finish the polygon first";

}
//---------------------------------------------------------------------------

void __fastcall TfrmDraw::ToolBtnPointClick(TObject *Sender)
{

ToolBtnLine->Down=false;
ToolBtnTri->Down=false;
ToolBtnRpoly->Down=false;
ToolBtnMirror->Down=false;
ToolBtnTrans->Down=false;
if (vertex!=0){
   for(int i=0;i<vertex;i++)
      lines[i].Hide(frmDraw->imgTransparent->Canvas);
   delete []lines;
   delete []points;
   vertex=0;
   Count->Enabled=true;
}
if (AutoPrint1->Checked && ToolBtnFree->Down==false && ToolBtnRotate->Down==false)
fig->Draw(frmDraw->imgTransparent->Canvas);


}
//---------------------------------------------------------------------------

void __fastcall TfrmDraw::ToolBtnLineClick(TObject *Sender)
{

ToolBtnPoint->Down=false;
ToolBtnCircle->Down=false;
ToolBtnRect->Down=false;
ToolBtnNpoly->Down=false;
ToolBtnFree->Down=false;
ToolBtnRotate->Down=false;
if (vertex!=0){
   for(int i=0;i<vertex;i++)
      lines[i].Hide(frmDraw->imgTransparent->Canvas);
   delete []lines;
   delete []points;
   vertex=0;
   Count->Enabled=true;
}
if (AutoPrint1->Checked && ToolBtnMirror->Down==false && ToolBtnTrans->Down==false)
fig->Draw(frmDraw->imgTransparent->Canvas);

}
//---------------------------------------------------------------------------


void __fastcall TfrmDraw::Clear1Click(TObject *Sender)
{
   Clear1->Checked=true;
   Solid1->Checked=false;
   DiagCross1->Checked=false;
   BDiagonal1->Checked=false;
   Horizontal1->Checked=false;
   Vertical1->Checked=false;
   Cross1->Checked=false;
   FDiagonal1->Checked=false;
   brushStyle=bsClear;
   fig->Hide(frmDraw->imgTransparent->Canvas);
   fig->SetBrushStyle(frmDraw->brushStyle);
   fig->Draw(frmDraw->imgTransparent->Canvas);
   
}
//---------------------------------------------------------------------------

void __fastcall TfrmDraw::Solid1Click(TObject *Sender)
{
   Clear1->Checked=false;
   Solid1->Checked=true;
   DiagCross1->Checked=false;
   BDiagonal1->Checked=false;
   Horizontal1->Checked=false;
   Vertical1->Checked=false;
   Cross1->Checked=false;
   FDiagonal1->Checked=false;
   brushStyle=bsSolid;
   fig->Hide(frmDraw->imgTransparent->Canvas);
   fig->SetBrushStyle(frmDraw->brushStyle);
   fig->Draw(frmDraw->imgTransparent->Canvas);

}
//---------------------------------------------------------------------------

void __fastcall TfrmDraw::DiagCross1Click(TObject *Sender)
{
   Clear1->Checked=false;
   Solid1->Checked=false;
   DiagCross1->Checked=true;
   BDiagonal1->Checked=false;
   Horizontal1->Checked=false;
   Vertical1->Checked=false;
   Cross1->Checked=false;
   FDiagonal1->Checked=false;
   brushStyle=bsDiagCross;
   fig->Hide(frmDraw->imgTransparent->Canvas);
   fig->SetBrushStyle(frmDraw->brushStyle);
   fig->Draw(frmDraw->imgTransparent->Canvas);

}
//---------------------------------------------------------------------------

void __fastcall TfrmDraw::BDiagonal1Click(TObject *Sender)
{
   Clear1->Checked=false;
   Solid1->Checked=false;
   DiagCross1->Checked=false;
   BDiagonal1->Checked=true;
   Horizontal1->Checked=false;
   Vertical1->Checked=false;
   Cross1->Checked=false;
   FDiagonal1->Checked=false;
   brushStyle=bsBDiagonal;
   fig->Hide(frmDraw->imgTransparent->Canvas);
   fig->SetBrushStyle(frmDraw->brushStyle);
   fig->Draw(frmDraw->imgTransparent->Canvas);

}
//---------------------------------------------------------------------------

void __fastcall TfrmDraw::Horizontal1Click(TObject *Sender)
{
   Clear1->Checked=false;
   Solid1->Checked=false;
   DiagCross1->Checked=false;
   BDiagonal1->Checked=false;
   Horizontal1->Checked=true;
   Vertical1->Checked=false;
   Cross1->Checked=false;
   FDiagonal1->Checked=false;
   brushStyle=bsHorizontal;
   fig->Hide(frmDraw->imgTransparent->Canvas);
   fig->SetBrushStyle(frmDraw->brushStyle);
   fig->Draw(frmDraw->imgTransparent->Canvas);

}
//---------------------------------------------------------------------------

void __fastcall TfrmDraw::Vertical1Click(TObject *Sender)
{
   Clear1->Checked=false;
   Solid1->Checked=false;
   DiagCross1->Checked=false;
   BDiagonal1->Checked=false;
   Horizontal1->Checked=false;
   Vertical1->Checked=true;
   Cross1->Checked=false;
   FDiagonal1->Checked=false;
   brushStyle=bsVertical;
   fig->Hide(frmDraw->imgTransparent->Canvas);
   fig->SetBrushStyle(frmDraw->brushStyle);
   fig->Draw(frmDraw->imgTransparent->Canvas);

}
//---------------------------------------------------------------------------

void __fastcall TfrmDraw::Cross1Click(TObject *Sender)
{
   Clear1->Checked=false;
   Solid1->Checked=false;
   DiagCross1->Checked=false;
   BDiagonal1->Checked=false;
   Horizontal1->Checked=false;
   Vertical1->Checked=false;
   Cross1->Checked=true;
   FDiagonal1->Checked=false;
   brushStyle=bsCross;
   fig->Hide(frmDraw->imgTransparent->Canvas);
   fig->SetBrushStyle(frmDraw->brushStyle);
   fig->Draw(frmDraw->imgTransparent->Canvas);

}
//---------------------------------------------------------------------------

void __fastcall TfrmDraw::FDiagonal1Click(TObject *Sender)
{
   Clear1->Checked=false;
   Solid1->Checked=false;
   DiagCross1->Checked=false;
   BDiagonal1->Checked=false;
   Horizontal1->Checked=false;
   Vertical1->Checked=false;
   Cross1->Checked=false;
   FDiagonal1->Checked=true;
   brushStyle=bsFDiagonal;
   fig->Hide(frmDraw->imgTransparent->Canvas);
   fig->SetBrushStyle(frmDraw->brushStyle);
   fig->Draw(frmDraw->imgTransparent->Canvas);

}
//---------------------------------------------------------------------------

void __fastcall TfrmDraw::Solid2Click(TObject *Sender)
{
   Solid2->Checked=true;
   Dash1->Checked=false;
   Dot1->Checked=false;
   DashDot1->Checked=false;
   DashDotDot1->Checked=false;
   Clear2->Checked=false;
   InsideFrame1->Checked=false;
   penStyle=psSolid;
   fig->Hide(frmDraw->imgTransparent->Canvas);
   fig->SetPenStyle(frmDraw->penStyle);
   fig->Draw(frmDraw->imgTransparent->Canvas);

}
//---------------------------------------------------------------------------

void __fastcall TfrmDraw::Dash1Click(TObject *Sender)
{
   Solid2->Checked=false;
   Dash1->Checked=true;
   Dot1->Checked=false;
   DashDot1->Checked=false;
   DashDotDot1->Checked=false;
   Clear2->Checked=false;
   InsideFrame1->Checked=false;
   penStyle=psDash;
   fig->Hide(frmDraw->imgTransparent->Canvas);
   fig->SetPenStyle(frmDraw->penStyle);
   fig->Draw(frmDraw->imgTransparent->Canvas);

}
//---------------------------------------------------------------------------

void __fastcall TfrmDraw::Dot1Click(TObject *Sender)
{
   Solid2->Checked=false;
   Dash1->Checked=false;
   Dot1->Checked=true;
   DashDot1->Checked=false;
   DashDotDot1->Checked=false;
   Clear2->Checked=false;
   InsideFrame1->Checked=false;
   penStyle=psDot;
   fig->Hide(frmDraw->imgTransparent->Canvas);
   fig->SetPenStyle(frmDraw->penStyle);
   fig->Draw(frmDraw->imgTransparent->Canvas);

}
//---------------------------------------------------------------------------

void __fastcall TfrmDraw::DashDot1Click(TObject *Sender)
{
   Solid2->Checked=false;
   Dash1->Checked=false;
   Dot1->Checked=false;
   DashDot1->Checked=true;
   DashDotDot1->Checked=false;
   Clear2->Checked=false;
   InsideFrame1->Checked=false;
   penStyle=psDashDot;
   fig->Hide(frmDraw->imgTransparent->Canvas);
   fig->SetPenStyle(frmDraw->penStyle);
   fig->Draw(frmDraw->imgTransparent->Canvas);

}
//---------------------------------------------------------------------------

void __fastcall TfrmDraw::DashDotDot1Click(TObject *Sender)
{
   Solid2->Checked=false;
   Dash1->Checked=false;
   Dot1->Checked=false;
   DashDot1->Checked=false;
   DashDotDot1->Checked=true;
   Clear2->Checked=false;
   InsideFrame1->Checked=false;
   penStyle=psDashDotDot;
   fig->Hide(frmDraw->imgTransparent->Canvas);
   fig->SetPenStyle(frmDraw->penStyle);
   fig->Draw(frmDraw->imgTransparent->Canvas);

}
//---------------------------------------------------------------------------

void __fastcall TfrmDraw::Clear2Click(TObject *Sender)
{
   Solid2->Checked=false;
   Dash1->Checked=false;
   Dot1->Checked=false;
   DashDot1->Checked=false;
   DashDotDot1->Checked=false;
   Clear2->Checked=true;
   InsideFrame1->Checked=false;
   penStyle=psClear;
   fig->Hide(frmDraw->imgTransparent->Canvas);
   fig->SetPenStyle(frmDraw->penStyle);
   fig->Draw(frmDraw->imgTransparent->Canvas);

}
//---------------------------------------------------------------------------

void __fastcall TfrmDraw::InsideFrame1Click(TObject *Sender)
{
   Solid2->Checked=false;
   Dash1->Checked=false;
   Dot1->Checked=false;
   DashDot1->Checked=false;
   DashDotDot1->Checked=false;
   Clear2->Checked=false;
   InsideFrame1->Checked=true;
   penStyle=psInsideFrame;
   fig->Hide(frmDraw->imgTransparent->Canvas);
   fig->SetPenStyle(frmDraw->penStyle);
   fig->Draw(frmDraw->imgTransparent->Canvas);

}
//---------------------------------------------------------------------------

void __fastcall TfrmDraw::PcolorClick(TObject *Sender)
{

if( ColorDialog->Execute())
{
   penColor = ColorDialog->Color;
   fig->Hide(frmDraw->imgTransparent->Canvas);
   fig->SetPenColor(frmDraw->penColor);
   fig->Draw(frmDraw->imgTransparent->Canvas);
}

}
//---------------------------------------------------------------------------

void __fastcall TfrmDraw::BcolorClick(TObject *Sender)
{

if( ColorDialog->Execute())
{
   brushColor = ColorDialog->Color;
   fig->Hide(frmDraw->imgTransparent->Canvas);
   fig->SetBrushColor(frmDraw->brushColor);
   fig->Draw(frmDraw->imgTransparent->Canvas);
}

}
//---------------------------------------------------------------------------

void __fastcall TfrmDraw::UpDownClick(TObject *Sender, TUDBtnType Button)
{
     Pwidth->Text=penWidth=UpDown->Position;
     fig->Hide(frmDraw->imgTransparent->Canvas);
     fig->SetPenWidth(frmDraw->penWidth);
     fig->Draw(frmDraw->imgTransparent->Canvas);
}
//---------------------------------------------------------------------------

void __fastcall TfrmDraw::ToolBtnCutClick(TObject *Sender)
{

fig->Hide(frmDraw->imgTransparent->Canvas);
f=fig;
fig= new VisualLine(Point2D(),Point2D());
fig->SetPenWidth(1);
fig->SetPenColor(clWhite);

}
//---------------------------------------------------------------------------

void __fastcall TfrmDraw::ToolBtnCopyClick(TObject *Sender)
{

if (!aux){
f=fig;
aux=true;

}

}
//---------------------------------------------------------------------------

void __fastcall TfrmDraw::ToolBtnPasteClick(TObject *Sender)
{

if (vertex!=0){
   for(int i=0;i<vertex;i++)
      lines[i].Hide(frmDraw->imgTransparent->Canvas);
   delete []lines;
   delete []points;
   vertex=0;
   Count->Enabled=true;
}
if (!aux){
   fig->Hide(frmDraw->imgTransparent->Canvas);
   delete fig;
   fig=f;

   aux=true;
}
   fig->Draw(frmDraw->imgTransparent->Canvas);
   
}
//---------------------------------------------------------------------------

void __fastcall TfrmDraw::AboutClick(TObject *Sender)
{
frmAbout->ShowModal();
}
//---------------------------------------------------------------------------

void __fastcall TfrmDraw::Clipboard1Click(TObject *Sender)
{
Clipboard()->Assign(imgTransparent->Picture);
}
//---------------------------------------------------------------------------

void __fastcall TfrmDraw::CopyAreatoClipboard1Click(TObject *Sender)
{
Clipboard()->Assign(imgTransparent->Picture);
}
//---------------------------------------------------------------------------

void __fastcall TfrmDraw::PasteFrom1Click(TObject *Sender)
{

TClipboard *pCB = Clipboard();
  if (pCB->HasFormat(CF_BITMAP))
  {
    Graphics::TBitmap *pBitmap = new Graphics::TBitmap();
    try
    {
      pBitmap->LoadFromClipboardFormat(CF_BITMAP, pCB->GetAsHandle(CF_BITMAP), 0);
      pBitmap->Transparent=true;
      imgTransparent->Canvas->Draw(0,0,pBitmap);
    }
    catch (...)
    {
      MessageBeep(0);
    }
    delete pBitmap;
  }
  else
    MessageBeep(0);

}
//---------------------------------------------------------------------------

void __fastcall TfrmDraw::ClearImage1Click(TObject *Sender)
{

TRect ARect;
imgTransparent->Canvas->CopyMode = cmWhiteness;
ARect = Rect(0, 0, imgTransparent->Width, imgTransparent->Height);
imgTransparent->Canvas->CopyRect(ARect, imgTransparent->Canvas, ARect);
imgTransparent->Canvas->CopyMode = cmSrcCopy;

}
//---------------------------------------------------------------------------


void __fastcall TfrmDraw::AutoPrint1Click(TObject *Sender)
{

if (AutoPrint1->Checked)
AutoPrint1->Checked=false;
else
AutoPrint1->Checked=true;

}
//---------------------------------------------------------------------------

void __fastcall TfrmDraw::Close1Click(TObject *Sender)
{
if( MessageDlg("Guardar Alteraes " ,
                mtConfirmation, TMsgDlgButtons() <<  mbYes <<  mbNo, 0)
                == mrYes )
SaveClick(Sender);
Close();
}
//---------------------------------------------------------------------------

void __fastcall TfrmDraw::FormMouseWheelUp(TObject *Sender,
      TShiftState Shift, TPoint &MousePos, bool &Handled)
{
if (vertex==0){
      fig->Hide(frmDraw->imgTransparent->Canvas);
      fig->ScaleOrig(1.1, 1.1);
      fig->Draw(frmDraw->imgTransparent->Canvas);
   }
   else
      StatusBar->SimpleText="Finish the polygon first";

}
//---------------------------------------------------------------------------

void __fastcall TfrmDraw::FormMouseWheelDown(TObject *Sender,
      TShiftState Shift, TPoint &MousePos, bool &Handled)
{
if (vertex==0){
      fig->Hide(frmDraw->imgTransparent->Canvas);
      fig->ScaleOrig(0.909, 0.909);
      fig->Draw(frmDraw->imgTransparent->Canvas);
   }
   else
      StatusBar->SimpleText="Finish the polygon first";
}
//---------------------------------------------------------------------------

